PF-build.sh 37 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Donnot istall 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machinename> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.0.6-Build_18
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with english only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and english only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selction GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR english only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Splitted the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Ardunio IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env gihub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards github fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modiffied checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers respository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for comming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have seperated build enviroments depening on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Audrino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multilanguage vairants it makes it easier to find missing or unused transltions.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. #### Start check if OSTYPE is supported
  128. OS_FOUND=$( command -v uname)
  129. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  130. linux*)
  131. TARGET_OS="linux"
  132. ;;
  133. msys*|cygwin*|mingw*)
  134. # or possible 'bash on windows'
  135. TARGET_OS='windows'
  136. ;;
  137. nt|win*)
  138. TARGET_OS='windows'
  139. ;;
  140. *)
  141. TARGET_OS='unknown'
  142. ;;
  143. esac
  144. # Windows
  145. if [ $TARGET_OS == "windows" ]; then
  146. if [ $(uname -m) == "x86_64" ]; then
  147. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  148. Processor="64"
  149. elif [ $(uname -m) == "i386" ]; then
  150. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  151. Processor="32"
  152. else
  153. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  154. echo "Please refer to the notes of build.sh$(tput sgr0)"
  155. exit 1
  156. fi
  157. # Linux
  158. elif [ $TARGET_OS == "linux" ]; then
  159. if [ $(uname -m) == "x86_64" ]; then
  160. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  161. Processor="64"
  162. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  163. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  164. Processor="32"
  165. else
  166. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  167. echo "Please refer to the notes of build.sh$(tput sgr0)"
  168. exit 1
  169. fi
  170. else
  171. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  172. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  173. echo "Read the notes of build.sh$(tput sgr0)"
  174. exit 1
  175. fi
  176. sleep 2
  177. #### End check if OSTYPE is supported
  178. #### Prepare bash environment and check if wget, zip and other needed things are available
  179. # Check wget
  180. if ! type wget > /dev/null; then
  181. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  182. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  183. exit 2
  184. fi
  185. # Check for zip
  186. if ! type zip > /dev/null; then
  187. if [ $TARGET_OS == "windows" ]; then
  188. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  189. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  190. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  191. echo "Run git Bash under Administrator privilege and"
  192. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  193. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  194. exit 3
  195. elif [ $TARGET_OS == "linux" ]; then
  196. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  197. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  198. exit 3
  199. fi
  200. fi
  201. # Check python ... needed during language build
  202. if ! type python > /dev/null; then
  203. if [ $TARGET_OS == "windows" ]; then
  204. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  205. exit 4
  206. elif [ $TARGET_OS == "linux" ]; then
  207. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  208. echo "As Python 2.x will not be maintained from 2020 please,"
  209. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  210. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  211. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  212. exit 4
  213. fi
  214. fi
  215. #### End prepare bash / Linux environment
  216. #### Set build environment
  217. ARDUINO_ENV="1.8.5"
  218. BUILD_ENV="1.0.6"
  219. BOARD="prusa_einsy_rambo"
  220. BOARD_PACKAGE_NAME="PrusaResearch"
  221. BOARD_VERSION="1.0.3"
  222. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/package_prusa3d_index.json"
  223. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  224. BOARD_FILENAME="prusa3dboards"
  225. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  226. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  227. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  228. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  229. LIB="PrusaLibrary"
  230. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  231. # List few useful data
  232. echo
  233. echo "Script path :" $SCRIPT_PATH
  234. echo "OS :" $OS
  235. echo "OS type :" $TARGET_OS
  236. echo ""
  237. echo "Ardunio IDE :" $ARDUINO_ENV
  238. echo "Build env :" $BUILD_ENV
  239. echo "Board :" $BOARD
  240. echo "Package name:" $BOARD_PACKAGE_NAME
  241. echo "Board v. :" $BOARD_VERSION
  242. echo "Specific Lib:" $LIB
  243. echo ""
  244. #### Start prepare building environment
  245. #Check if build exists and creates it if not
  246. if [ ! -d "../PF-build-dl" ]; then
  247. mkdir ../PF-build-dl || exit 5
  248. fi
  249. cd ../PF-build-dl || exit 6
  250. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  251. # Check if PF-build-env-<version> exists and downloads + creates it if not
  252. # The build environment is based on the supported Arduino IDE portable version with some changes
  253. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  254. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  255. mkdir ../PF-build-env-$BUILD_ENV
  256. sleep 5
  257. fi
  258. # Download and extract supported Arduino IDE depending on OS
  259. # Windows
  260. if [ $TARGET_OS == "windows" ]; then
  261. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  262. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  263. sleep 2
  264. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 7
  265. echo "$(tput sgr 0)"
  266. fi
  267. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  268. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  269. sleep 2
  270. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 7
  271. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  272. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  273. echo "$(tput sgr0)"
  274. fi
  275. fi
  276. # Linux
  277. if [ $TARGET_OS == "linux" ]; then
  278. # 32 or 64 bit version
  279. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  280. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  281. sleep 2
  282. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  283. echo "$(tput sgr 0)"
  284. fi
  285. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  286. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  287. sleep 2
  288. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  289. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  290. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  291. echo "$(tput sgr0)"
  292. fi
  293. fi
  294. # Make Arduino IDE portable
  295. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  296. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  297. fi
  298. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  299. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  300. fi
  301. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  302. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  303. fi
  304. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  305. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  306. fi
  307. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  308. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  309. fi
  310. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  311. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  312. fi
  313. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  314. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  315. fi
  316. # Change Arduino IDE preferences
  317. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  318. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  319. sleep 2
  320. echo "update.check"
  321. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  322. echo "board"
  323. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  324. echo "editor.linenumbers"
  325. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  326. echo "boardsmanager.additional.urls"
  327. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  328. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  329. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  330. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  331. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  332. echo "$(tput sgr0)"
  333. fi
  334. # Download and extract Prusa Firmware related parts
  335. # Download and extract PrusaResearchRambo board
  336. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  337. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  338. sleep 2
  339. wget $BOARD_FILE_URL || exit 9
  340. fi
  341. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  342. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  343. sleep 2
  344. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  345. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  346. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  347. fi
  348. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  349. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  350. fi
  351. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  352. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  353. fi
  354. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  355. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  356. fi
  357. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  358. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  359. echo "$(tput sgr 0)"
  360. fi
  361. # Download and extract Prusa Firmware specific library files
  362. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  363. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  364. sleep 2
  365. wget $PF_BUILD_FILE_URL || exit 11
  366. echo "$(tput sgr 0)"
  367. fi
  368. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  369. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  370. sleep 2
  371. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 12
  372. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  373. echo "$(tput sgr0)"
  374. fi
  375. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  376. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  377. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  378. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  379. sleep 2
  380. fi
  381. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  382. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  383. sleep 2
  384. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  385. sleep 2
  386. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  387. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  388. echo "$(tput sgr0)"
  389. fi
  390. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  391. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  392. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  393. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  394. sleep 2
  395. echo "$(tput sgr0)"
  396. exit 13
  397. fi
  398. #### End prepare building
  399. #### Start
  400. cd $SCRIPT_PATH
  401. # First argument defines which variant of the Prusa Firmware will be compiled
  402. if [ -z "$1" ] ; then
  403. # Select which variant of the Prusa Firmware will be compiled, like
  404. PS3="Select a variant: "
  405. while IFS= read -r -d $'\0' f; do
  406. options[i++]="$f"
  407. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  408. select opt in "${options[@]}" "All" "Quit"; do
  409. case $opt in
  410. *.h)
  411. VARIANT=$(basename "$opt" ".h")
  412. VARIANTS[i++]="$opt"
  413. break
  414. ;;
  415. "All")
  416. VARIANT="All"
  417. VARIANTS=${options[*]}
  418. break
  419. ;;
  420. "Quit")
  421. echo "You chose to stop"
  422. exit
  423. ;;
  424. *)
  425. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  426. ;;
  427. esac
  428. done
  429. else
  430. if [ -f "$SCRIPT_PATH/Firmware/variants/$1" ] ; then
  431. VARIANTS=$1
  432. else
  433. echo "$(tput setaf 1)$1 could not be found in Firmware/variants please choose a valid one$(tput setaf 2)"
  434. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  435. echo "$(tput sgr0)"
  436. exit 21
  437. fi
  438. fi
  439. #Second argument defines if it is an english only version. Known values EN_ONLY / ALL
  440. #Check default language mode
  441. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  442. if [ -z "$2" ] ; then
  443. PS3="Select a language: "
  444. echo
  445. echo "Which lang-build do you want?"
  446. select yn in "Multi languages" "English only"; do
  447. case $yn in
  448. "Multi languages")
  449. LANGUAGES="ALL"
  450. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  451. break
  452. ;;
  453. "English only")
  454. LANGUAGES="EN_ONLY"
  455. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  456. break
  457. ;;
  458. *)
  459. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  460. ;;
  461. esac
  462. done
  463. else
  464. if [[ "$2" == "ALL" || "$2" == "EN_ONLY" ]] ; then
  465. LANGUAGES=$2
  466. else
  467. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  468. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as 2nd argument!"
  469. exit 22
  470. fi
  471. fi
  472. #Check if DEV_STATUS is selected via argument 3
  473. if [ ! -z "$3" ] ; then
  474. if [[ "$3" == "GOLD" || "$3" == "RC" || "$3" == "BETA" || "$3" == "ALPHA" || "$3" == "DEVEL" || "$3" == "DEBUG" ]] ; then
  475. DEV_STATUS_SELECTED=$3
  476. else
  477. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  478. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL' or 'DEBUG'$(tput sgr0) are allowed as 3rd argument!$(tput sgr0)"
  479. exit 23
  480. fi
  481. fi
  482. #Set BUILD_ENV_PATH
  483. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 24
  484. BUILD_ENV_PATH="$( pwd -P )"
  485. cd ../..
  486. #Checkif BUILD_PATH exists and if not creates it
  487. if [ ! -d "Prusa-Firmware-build" ]; then
  488. mkdir Prusa-Firmware-build || exit 25
  489. fi
  490. #Set the BUILD_PATH for Arduino IDE
  491. cd Prusa-Firmware-build || exit 26
  492. BUILD_PATH="$( pwd -P )"
  493. for v in ${VARIANTS[*]}
  494. do
  495. VARIANT=$(basename "$v" ".h")
  496. # Find firmware version in Configuration.h file and use it to generate the hex filename
  497. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  498. # Find build version in Configuration.h file and use it to generate the hex filename
  499. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  500. # Check if the motherboard is an EINSY and if so only one hex file will generated
  501. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  502. # Check development status
  503. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  504. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  505. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  506. DEV_STATUS="RC"
  507. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  508. DEV_STATUS="ALPHA"
  509. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  510. DEV_STATUS="BETA"
  511. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  512. DEV_STATUS="DEVEL"
  513. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  514. DEV_STATUS="DEBUG"
  515. else
  516. DEV_STATUS="UNKNOWN"
  517. echo
  518. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  519. PS3="Select YES only if source code is tested and trusted: "
  520. select yn in "Yes" "No"; do
  521. case $yn in
  522. Yes)
  523. DEV_STATUS="GOLD"
  524. DEV_STATUS_SELECTED="GOLD"
  525. break
  526. ;;
  527. No)
  528. DEV_STATUS="UNKNOWN"
  529. DEV_STATUS_SELECTED="UNKNOWN"
  530. break
  531. ;;
  532. *)
  533. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  534. ;;
  535. esac
  536. done
  537. fi
  538. else
  539. DEV_STATUS=$DEV_STATUS_SELECTED
  540. fi
  541. #Prepare hex files folders
  542. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  543. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 27
  544. fi
  545. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  546. #Check if exactly the same hexfile already exists
  547. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  548. echo ""
  549. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  550. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  551. read -t 10 -p "Press Enter to continue..."
  552. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  553. echo ""
  554. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  555. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  556. read -t 10 -p "Press Enter to continue..."
  557. fi
  558. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  559. echo ""
  560. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  561. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  562. read -t 10 -p "Press Enter to continue..."
  563. fi
  564. #List some useful data
  565. echo "$(tput setaf 2)$(tput setab 7) "
  566. echo "Variant :" $VARIANT
  567. echo "Firmware :" $FW
  568. echo "Build # :" $BUILD
  569. echo "Dev Check :" $DEV_CHECK
  570. echo "DEV Status :" $DEV_STATUS
  571. echo "Motherboard:" $MOTHERBOARD
  572. echo "Languages :" $LANGUAGES
  573. echo "Hex-file Folder:" $OUTPUT_FOLDER
  574. echo "$(tput sgr0)"
  575. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  576. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  577. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  578. else
  579. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  580. read -t 10 -p "Press Enter to continue..."
  581. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  582. fi
  583. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  584. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  585. # set FW_REPOSITORY
  586. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  587. #Prepare english only or multilanguage version to be build
  588. if [ $LANGUAGES == "ALL" ]; then
  589. echo " "
  590. echo "Multi-language firmware will be built"
  591. echo " "
  592. else
  593. echo " "
  594. echo "English only language firmware will be built"
  595. echo " "
  596. fi
  597. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  598. # if [ $TARGET_OS == "windows" ]; then
  599. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  600. # fi
  601. #### End of Prepare building
  602. #### Start building
  603. export ARDUINO=$BUILD_ENV_PATH
  604. #echo $BUILD_ENV_PATH
  605. #export BUILDER=$ARDUINO/arduino-builder
  606. echo
  607. #read -t 5 -p "Press Enter..."
  608. echo
  609. echo "Start to build Prusa Firmware ..."
  610. echo "Using variant $VARIANT$(tput setaf 3)"
  611. sleep 2
  612. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  613. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  614. echo "$(tput sgr 0)"
  615. if [ $LANGUAGES == "ALL" ]; then
  616. echo "$(tput setaf 2)"
  617. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  618. echo "$(tput sgr 0)"
  619. sleep 2
  620. cd $SCRIPT_PATH/lang
  621. echo "$(tput setaf 3)"
  622. ./config.sh || exit 31
  623. echo "$(tput sgr 0)"
  624. # Check if previous languages and firmware build exist and if so clean them up
  625. if [ -f "lang_en.tmp" ]; then
  626. echo ""
  627. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  628. read -t 10 -p "Press Enter to continue..."
  629. echo "$(tput setaf 3)"
  630. ./lang-clean.sh
  631. echo "$(tput sgr 0)"
  632. fi
  633. if [ -f "progmem.out" ]; then
  634. echo ""
  635. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  636. read -t 10 -p "Press Enter to continue..."
  637. echo "$(tput setaf 3)"
  638. ./fw-clean.sh
  639. echo "$(tput sgr 0)"
  640. fi
  641. # build languages
  642. echo "$(tput setaf 3)"
  643. ./lang-build.sh || exit 32
  644. # Combine compiled firmware with languages
  645. ./fw-build.sh || exit 33
  646. cp not_tran.txt not_tran_$VARIANT.txt
  647. cp not_used.txt not_used_$VARIANT.txt
  648. echo "$(tput sgr 0)"
  649. # Check if the motherboard is an EINSY and if so only one hex file will generated
  650. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  651. # If the motherboard is an EINSY just copy one hexfile
  652. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  653. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  654. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  655. else
  656. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  657. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  658. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  659. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  660. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  661. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  662. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  663. if [ $TARGET_OS == "windows" ]; then
  664. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  665. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  666. elif [ $TARGET_OS == "linux" ]; then
  667. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  668. fi
  669. fi
  670. # Cleanup after build
  671. echo "$(tput setaf 3)"
  672. ./fw-clean.sh || exit 34
  673. ./lang-clean.sh || exit 35
  674. echo "$(tput sgr 0)"
  675. else
  676. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  677. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 34
  678. fi
  679. # Cleanup Firmware
  680. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 36
  681. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  682. then
  683. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  684. fi
  685. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  686. then
  687. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  688. fi
  689. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  690. then
  691. rm $SCRIPT_PATH/lang/not_tran.txt
  692. fi
  693. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  694. then
  695. rm $SCRIPT_PATH/lang/not_used.txt
  696. fi
  697. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  698. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  699. echo $MULTI_LANGUAGE_CHECK
  700. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  701. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  702. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  703. sleep 5
  704. done
  705. # Switch to hex path and list build files
  706. cd $SCRIPT_PATH
  707. cd ..
  708. echo "$(tput setaf 2) "
  709. echo " "
  710. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  711. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  712. #### End building